VTK: vtkPropPicker Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkPropPicker Class Reference

pick an actor/prop using graphics hardware More...

`#include <vtkPropPicker.h>`

Inheritance diagram for vtkPropPicker:
[legend]
Collaboration diagram for vtkPropPicker:
[legend]

## Public Types
typedef vtkAbstractPropPicker | Superclass
Public Types inherited from vtkAbstractPropPicker
typedef vtkAbstractPicker | Superclass
Public Types inherited from vtkAbstractPicker
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkPropPicker * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
int | PickProp (double selectionX, double selectionY, vtkRenderer *renderer)
| Perform the pick and set the PickedProp ivar. More...
int | PickProp (double selectionX, double selectionY, vtkRenderer *renderer, vtkPropCollection *pickfrom)
| Perform a pick from the user-provided list of vtkProps and not from the list of vtkProps that the render maintains. More...
int | Pick (double selectionX, double selectionY, double selectionZ, vtkRenderer *renderer) override
| override superclasses' Pick() method. More...
int | Pick (double selectionPt[3], vtkRenderer *renderer)
int | Pick3DPoint (double selectionPt[3], vtkRenderer *ren) override
| Perform pick operation with selection point provided. More...
int | PickProp3DPoint (double pos[3], vtkRenderer *renderer)
| Perform the pick and set the PickedProp ivar. More...
int | PickProp3DPoint (double pos[3], vtkRenderer *renderer, vtkPropCollection *pickfrom)
| Perform a pick from the user-provided list of vtkProps and not from the list of vtkProps that the render maintains. More...
virtual int | PickProp3DRay (double selectionPt[3], double eventWorldOrientation[4], vtkRenderer *renderer, vtkPropCollection *pickfrom)
| Perform a pick from the user-provided list of vtkProps. More...
int | Pick3DRay (double selectionPt[3], double orient[4], vtkRenderer *ren) override
| Perform pick operation with selection point provided. More...
Public Member Functions inherited from vtkAbstractPropPicker
vtkAbstractPropPicker * | NewInstance () const
virtual vtkProp * | GetViewProp ()
| Return the vtkProp that has been picked. More...
virtual vtkProp3D * | GetProp3D ()
| Return the vtkProp that has been picked. More...
virtual vtkActor * | GetActor ()
| Return the vtkActor that has been picked. More...
virtual vtkActor2D * | GetActor2D ()
| Return the vtkActor2D that has been picked. More...
virtual vtkVolume * | GetVolume ()
| Return the vtkVolume that has been picked. More...
virtual vtkAssembly * | GetAssembly ()
| Return the vtkAssembly that has been picked. More...
virtual vtkPropAssembly * | GetPropAssembly ()
| Return the vtkPropAssembly that has been picked. More...
virtual void | SetPath (vtkAssemblyPath *)
| Return the vtkAssemblyPath that has been picked. More...
virtual vtkAssemblyPath * | GetPath ()
| Return the vtkAssemblyPath that has been picked. More...
Public Member Functions inherited from vtkAbstractPicker
vtkAbstractPicker * | NewInstance () const
int | Pick (double selectionPt[3], vtkRenderer *ren)
| provided. More...
void | InitializePickList ()
| Initialize list of actors in pick list. More...
void | AddPickList (vtkProp *)
| Add an actor to the pick list. More...
void | DeletePickList (vtkProp *)
| Delete an actor from the pick list. More...
vtkPropCollection * | GetPickList ()
| Return the list of actors in the PickList. More...
virtual vtkRenderer * | GetRenderer ()
| Get the renderer in which pick event occurred. More...
virtual double * | GetSelectionPoint ()
| Get the selection point in screen (pixel) coordinates. More...
virtual void | GetSelectionPoint (double data[3])
| Get the selection point in screen (pixel) coordinates. More...
virtual double * | GetPickPosition ()
| Return position in global coordinates of pick point. More...
virtual void | GetPickPosition (double data[3])
| Return position in global coordinates of pick point. More...
virtual void | SetPickFromList (vtkTypeBool)
| Use these methods to control whether to limit the picking to this list (rather than renderer's actors). More...
virtual vtkTypeBool | GetPickFromList ()
| Use these methods to control whether to limit the picking to this list (rather than renderer's actors). More...
virtual void | PickFromListOn ()
| Use these methods to control whether to limit the picking to this list (rather than renderer's actors). More...
virtual void | PickFromListOff ()
| Use these methods to control whether to limit the picking to this list (rather than renderer's actors). More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkPropPicker * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkPropPicker * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkAbstractPropPicker
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAbstractPropPicker * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkAbstractPicker
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAbstractPicker * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkPropPicker ()
| ~vtkPropPicker () override
void | Initialize () override
Protected Member Functions inherited from vtkAbstractPropPicker
| vtkAbstractPropPicker ()
| ~vtkAbstractPropPicker () override
Protected Member Functions inherited from vtkAbstractPicker
| vtkAbstractPicker ()
| ~vtkAbstractPicker () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkPropCollection * | PickFromProps
vtkWorldPointPicker * | WorldPointPicker
Protected Attributes inherited from vtkAbstractPropPicker
vtkAssemblyPath * | Path
Protected Attributes inherited from vtkAbstractPicker
vtkRenderer * | Renderer
double | SelectionPoint [3]
double | PickPosition [3]
vtkTypeBool | PickFromList
vtkPropCollection * | PickList
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

pick an actor/prop using graphics hardware

vtkPropPicker is used to pick an actor/prop given a selection point (in display coordinates) and a renderer. This class uses graphics hardware/rendering system to pick rapidly (as compared to using ray casting as does vtkCellPicker and vtkPointPicker). This class determines the actor/prop and pick position in world coordinates; point and cell ids are not determined.

See also
  vtkPicker vtkWorldPointPicker vtkCellPicker vtkPointPicker

Events:
  vtkCommand::EndPickEvent vtkCommand::PickEvent vtkCommand::StartPickEvent

Online Examples:

Tests:
  vtkPropPicker (Tests)

Definition at line 43 of file vtkPropPicker.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkAbstractPropPicker vtkPropPicker::Superclass

Definition at line 48 of file vtkPropPicker.h.

## Constructor & Destructor Documentation

## ◆ vtkPropPicker()

vtkPropPicker::vtkPropPicker | ( |  | ) |
| protected

## ◆ ~vtkPropPicker()

vtkPropPicker::~vtkPropPicker | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkPropPicker* vtkPropPicker::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkPropPicker::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkPropPicker::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkAbstractPropPicker.

Reimplemented in vtkZSpaceHardwarePicker, and vtkVRHardwarePicker.

## ◆ SafeDownCast()

static vtkPropPicker* vtkPropPicker::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkPropPicker::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkAbstractPropPicker.

Reimplemented in vtkZSpaceHardwarePicker, and vtkVRHardwarePicker.

## ◆ NewInstance()

vtkPropPicker* vtkPropPicker::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkPropPicker::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkAbstractPropPicker.

Reimplemented in vtkZSpaceHardwarePicker, and vtkVRHardwarePicker.

## ◆ PickProp() [1/2]

int vtkPropPicker::PickProp | ( | double | selectionX,
|  | double | selectionY,
|  | vtkRenderer * | renderer
| ) |  |

Perform the pick and set the PickedProp ivar.

If something is picked, a 1 is returned, otherwise 0 is returned. Use the GetViewProp() method to get the instance of vtkProp that was picked. Props are picked from the renderers list of pickable Props.

## ◆ PickProp() [2/2]

int vtkPropPicker::PickProp | ( | double | selectionX,
|  | double | selectionY,
|  | vtkRenderer * | renderer,
|  | vtkPropCollection * | pickfrom
| ) |  |

Perform a pick from the user-provided list of vtkProps and not from the list of vtkProps that the render maintains.

## ◆ Pick() [1/2]

int vtkPropPicker::Pick | ( | double | selectionX,
|  | double | selectionY,
|  | double | selectionZ,
|  | vtkRenderer * | renderer
| ) |  |
| overridevirtual

override superclasses' Pick() method.

Implements vtkAbstractPicker.

## ◆ Pick() [2/2]

int vtkPropPicker::Pick | ( | double | selectionPt[3],
|  | vtkRenderer * | renderer
| ) |  |
| inline

Definition at line 70 of file vtkPropPicker.h.

## ◆ Pick3DPoint()

int vtkPropPicker::Pick3DPoint | ( | double | selectionPt[3],
|  | vtkRenderer * | ren
| ) |  |
| overridevirtual

Perform pick operation with selection point provided.

The selectionPt is in world coordinates. Return non-zero if something was successfully picked.

Reimplemented from vtkAbstractPicker.

## ◆ PickProp3DPoint() [1/2]

int vtkPropPicker::PickProp3DPoint | ( | double | pos[3],
|  | vtkRenderer * | renderer
| ) |  |

Perform the pick and set the PickedProp ivar.

If something is picked, a 1 is returned, otherwise 0 is returned. Use the GetViewProp() method to get the instance of vtkProp that was picked. Props are picked from the renderers list of pickable Props.

## ◆ PickProp3DPoint() [2/2]

int vtkPropPicker::PickProp3DPoint | ( | double | pos[3],
|  | vtkRenderer * | renderer,
|  | vtkPropCollection * | pickfrom
| ) |  |

Perform a pick from the user-provided list of vtkProps and not from the list of vtkProps that the render maintains.

## ◆ PickProp3DRay()

virtual int vtkPropPicker::PickProp3DRay | ( | double | selectionPt[3],
|  | double | eventWorldOrientation[4],
|  | vtkRenderer * | renderer,
|  | vtkPropCollection * | pickfrom
| ) |  |
| virtual

Perform a pick from the user-provided list of vtkProps.

## ◆ Pick3DRay()

int vtkPropPicker::Pick3DRay | ( | double | selectionPt[3],
|  | double | orient[4],
|  | vtkRenderer * | ren
| ) |  |
| overridevirtual

Perform pick operation with selection point provided.

The selectionPt is in world coordinates. Return non-zero if something was successfully picked.

Reimplemented from vtkAbstractPicker.

## ◆ Initialize()

void vtkPropPicker::Initialize | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from vtkAbstractPropPicker.

Reimplemented in vtkVRHardwarePicker.

## Member Data Documentation

## ◆ PickFromProps

vtkPropCollection* vtkPropPicker::PickFromProps
| protected

Definition at line 115 of file vtkPropPicker.h.

## ◆ WorldPointPicker

vtkWorldPointPicker* vtkPropPicker::WorldPointPicker
| protected

Definition at line 118 of file vtkPropPicker.h.

The documentation for this class was generated from the following file:

- Rendering/Core/vtkPropPicker.h